#include <stdlib.h>
#include <stdio.h>
#include <gmp.h>

int
main(int argc, char *argv[])
{ 
  unsigned long k, i;
  mpz_t hh, pp, pm, test, aux;

  mpz_init(pp);
  mpz_init(pm);
  mpz_init(hh);
  mpz_init(test);
  mpz_init(aux);    

  mpz_set_str(hh,argv[1],10);
  k = atol(argv[2]); /* Lemos h e k. */

  mpz_ui_pow_ui(pm,(long)(2),k);
  mpz_mul(pm,pm,hh);
  mpz_fdiv_q_2exp(aux,pm,(long)(1)); 
  mpz_add_ui(pp,pm,(long)(1)); 
  /* Calculamos pp = hh * 2^k + 1, pm = pp - 1 e aux = (pp-1)/2. */

  printf("%s * 2^%ld + 1 = ",argv[1],k);
  mpz_out_str(stdout,10,pp);
  printf("\n");
  
  mpz_set_ui(test,(long)(2));
  mpz_powm(test,test,aux,pp); 
  if ( mpz_cmp(test,pm) == 0 )
  { printf("%s * 2^%ld + 1  primo.\n",argv[1],k); return(0); }
  if ( mpz_cmp_ui(test,(long)(1)) != 0 )
  { printf("%s * 2^%ld + 1  composto.\n",argv[1],k); return(0); }

  mpz_set_ui(test,(long)(3));
  mpz_powm(test,test,aux,pp); 
  if ( mpz_cmp(test,pm) == 0 )
  { printf("%s * 2^%ld + 1  primo.\n",argv[1],k); return(0); }
  if ( mpz_cmp_ui(test,(long)(1)) != 0 )
  { printf("%s * 2^%ld + 1  composto.\n",argv[1],k); return(0); }

  mpz_set_ui(test,(long)(5));
  mpz_powm(test,test,aux,pp); 
  if ( mpz_cmp(test,pm) == 0 )
  { printf("%s * 2^%ld + 1  primo.\n",argv[1],k); return(0); }
  if ( mpz_cmp_ui(test,(long)(1)) != 0 )
  { printf("%s * 2^%ld + 1  composto.\n",argv[1],k); return(0); }

  mpz_set_ui(test,(long)(7));
  mpz_powm(test,test,aux,pp); 
  if ( mpz_cmp(test,pm) == 0 )
  { printf("%s * 2^%ld + 1  primo.\n",argv[1],k); return(0); }
  if ( mpz_cmp_ui(test,(long)(1)) != 0 )
  { printf("%s * 2^%ld + 1  composto.\n",argv[1],k); return(0); }

  mpz_set_ui(test,(long)(11));
  mpz_powm(test,test,aux,pp); 
  if ( mpz_cmp(test,pm) == 0 )
  { printf("%s * 2^%ld + 1  primo.\n",argv[1],k); return(0); }
  if ( mpz_cmp_ui(test,(long)(1)) != 0 )
  { printf("%s * 2^%ld + 1  composto.\n",argv[1],k); return(0); }

  mpz_set_ui(test,(long)(13));
  mpz_powm(test,test,aux,pp); 
  if ( mpz_cmp(test,pm) == 0 )
  { printf("%s * 2^%ld + 1  primo.\n",argv[1],k); return(0); }
  if ( mpz_cmp_ui(test,(long)(1)) != 0 )
  { printf("%s * 2^%ld + 1  composto.\n",argv[1],k); return(0); }

  mpz_set_ui(test,(long)(17));
  mpz_powm(test,test,aux,pp); 
  if ( mpz_cmp(test,pm) == 0 )
  { printf("%s * 2^%ld + 1  primo.\n",argv[1],k); return(0); }
  if ( mpz_cmp_ui(test,(long)(1)) != 0 )
  { printf("%s * 2^%ld + 1  composto.\n",argv[1],k); return(0); }

  mpz_set_ui(test,(long)(19));
  mpz_powm(test,test,aux,pp); 
  if ( mpz_cmp(test,pm) == 0 )
  { printf("%s * 2^%ld + 1  primo.\n",argv[1],k); return(0); }
  if ( mpz_cmp_ui(test,(long)(1)) != 0 )
  { printf("%s * 2^%ld + 1  composto.\n",argv[1],k); return(0); }

  for ( i = 23 ; i < 1000 ; i++ )
  {
    mpz_set_ui(test,(long)(i));
    if ( mpz_probab_prime_p(test,25) )
    {
      mpz_powm(test,test,aux,pp); 
      if ( mpz_cmp(test,pm) == 0 )
      { printf("%s * 2^%ld + 1  primo.\n",argv[1],k); return(0); }
      if ( mpz_cmp_ui(test,(long)(1)) != 0 )
      { printf("%s * 2^%ld + 1  composto.\n",argv[1],k); return(0); }
    }
  }


  printf("%s * 2^%ld + 1: difcil... \n",argv[1],k);
  return(0);
}
